//+------------------------------------------------------------------
//|                                                           mladen 
//|                                                                  
//| Long term Heikin-Ashi Candlestick Oscillator                     
//| Developed by Sylvain Vervoort (TASC Jul 2012)                    
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   PaleVioletRed
#property indicator_width1   2
#property indicator_minimum -1
#property indicator_maximum  101
#property indicator_level1   50

//
//
//
//
//

extern int    Length     = 55;
extern double CandleSize = 1.1;
extern int    LtLength   = 60;

//
//
//
//
//

double buffer1[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); 
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][11];
#define _hao      0
#define _hac      1
#define _keeping1 2
#define _keepalll 3
#define _keeping2 4
#define _keepall2 5
#define _dtr      6
#define _utr      7
#define _upw      8
#define _dnw      9
#define _ltResult 10

//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
   int i,r,limit;

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = Bars-countedBars;
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
   
   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i >= 0; i--,r++)
   {
      double hac   = haC(i,r);
      double temaa = zeroLagTema(hac                 ,Length,i,0);
      double temab = zeroLagTema((High[i]+Low[i])/2.0,Length,i,1);

      //
      //
      //
      //
      //

      bool keep1 = (hac>work[r][_hao] || work[r-1][_hac]>=work[r-1][_hao] || Close[i]>= hac || High[i]>High[i+1] || Low[i]>Low[i+1]);
      bool keep2 = (temab-temaa) >= 0;
      bool keep3 = MathAbs( Close[i]-Open[i]) < (High[i]-Low[i])*CandleSize	&& High[i] >= Low[i+1];
           work[r][_keeping1] = keep1 || keep2;
           work[r][_keepalll] = work[r][_keeping1] || (work[r-1][_keeping1] && Close[i]>=Open[i] || Close[i]>=Close[i+1]);
           work[r][_utr]      = work[r][_keepalll] || (work[r-1][_keepalll] && keep3);

           //
           //
           //
           //
           //
           
           keep1   = (hac<work[r][_hao] || work[r-1][_hac]<work[r-1][_hao]);
           keep2   = (temab-temaa) < 0;
           keep3   = MathAbs( Close[i]-Open[i]) < (High[i]-Low[i])*CandleSize	&& Low[i] <= High[i+1];
           work[r][_keeping2] = keep1 || keep2;
           work[r][_keepall2] = work[r][_keeping2] || (work[r-1][_keeping2] && Close[i]<Open[i] || Close[i]<Close[i+1]);
           work[r][_dtr]      = work[r][_keepall2] || (work[r-1][_keepall2] && keep3);
           work[r][_upw]      = work[r][_dtr]==false && work[r-1][_dtr]==true && work[r][_utr]==true;
           work[r][_dnw]      = work[r][_utr]==false && work[r-1][_utr]==true && work[r][_dtr]==true;
           
           
      //
      //
      //
      //
      //
      
      bool ltSell = Close[i]<iMA(NULL,0,LtLength,0,MODE_EMA,PRICE_CLOSE,i);
      bool result = false;
         for (int k=1; k<50; k++) if (work[r-k][_upw] == true || work[r-k][_dnw] == true) break;
         while (true)
         {
            if (work[r][_upw] == true           ) { result = true;  break; }
            if (work[r][_dnw] == true           ) { result = false; break; }
            if (k<50 && work[r-k][_upw] == true ) { result = true;  break; }
                                                                    break;
         }                                                           
         work[r][_ltResult] = work[r-1][_ltResult];
         while (true)
         {
            if (result == true            ) { work[r][_ltResult]=true;  break; }
            if (result == false && ltSell ) { work[r][_ltResult]=false; break; }
                                                                        break;
         }                                                                       
         while (true)
         {
            if (result == true                                ) { buffer1[i] = 100; break; }
            if (result == false && work[r][_ltResult] == true ) { buffer1[i] =  50; break; }
                                                                  buffer1[i] =   0; break; 
         }                                                              
   }
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double haC(int i, int r)
{
   double haClose = (High[i+1]+Low[i+1]+Open[i+1]+Close[i+1])/4.0;
   double median  = (High[i]+Low[i])/2.0;
   double haOpen  = (haClose+work[r-1][_hao])/2.0;
      double haC  = (median + haOpen + MathMax(haOpen,High[i])+ MathMin(haOpen,Low[i]))/4.0;
      work[r][_hao] = haOpen;      
      work[r][_hac] = haC;      
   return(haC);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double zeroLagTema(double price, double period,int i,int buff)
{
   buff *= 2;
      double temaa = iTema(price,period,i,buff+0);
      double temab = iTema(temaa,period,i,buff+1);
      return(2.0*temaa-temab); 
}

//
//
//
//
//

double workTema[][12];
#define _ema1 0
#define _ema2 1
#define _ema3 2

double iTema(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= Bars) ArrayResize(workTema,Bars); instanceNo*=3; int r = Bars-i-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workTema[r][_ema1+instanceNo] = workTema[r-1][_ema1+instanceNo]+alpha*(price                        -workTema[r-1][_ema1+instanceNo]);
          workTema[r][_ema2+instanceNo] = workTema[r-1][_ema2+instanceNo]+alpha*(workTema[r][_ema1+instanceNo]-workTema[r-1][_ema2+instanceNo]);
          workTema[r][_ema3+instanceNo] = workTema[r-1][_ema3+instanceNo]+alpha*(workTema[r][_ema2+instanceNo]-workTema[r-1][_ema3+instanceNo]);
   return(workTema[r][_ema3+instanceNo]+3.0*(workTema[r][_ema1+instanceNo]-workTema[r][_ema2+instanceNo]));
}